<?php
/*
	Copyright  Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym
*/

#   
class English
{
	const
		ALPHABET='abcdefghijklmnopqrstuvwxyz';#  

	/**
	 *    
	 *
	 * @param int $n 
	 * @param array $forms  .  array('','  ')
	 */
	public static function Plural($n,array$forms)
	{
		return$n==1 ? $forms[0] : $forms[1];
	}

	/**
	 *   
	 *
	 * @param int|string $d     ,  timestamp
	 * @param string $t  : t -  , d -  , dt -    , my -   , fd -  , fdt -    
	 * @param array $a  ,    advanced    "", "", ""
	 */
	public static function Date($d=false,$t='',$a=array())
	{
		if(!$d)
			$d=time();
		elseif(is_array($d))
		{
			$d+=array_combine(array('H','i','s','n','j','Y'),explode(',',date('H,i,s,n,j,Y')));
			$d=mktime($d['H'],$d['i'],$d['s'],$d['n'],$d['j'],$d['Y']);
		}
		elseif(!is_int($d))
			$d=strtotime($d);
		if(!$d)
			return;
		switch($t)
		{
			case't':#time
				return date('H:i:s',$d);
			case'd':#date
				return date('Y-m-d',$d);
			case'dt':#datetime
			default:
				return date('Y-m-d H:i:s',$d);

			case'my':#Month year
				return date('F Y',$d);
			case'fd':#full date
				$a+=array('advanced'=>true);
				return self::DateText($d,$a['advanced']);
			case'fdt':#full datetime
				$a+=array('advanced'=>true);
				return self::DateText($d,$a['advanced']).date(' H:i',$d);
		}
	}

	/**
	 *   
	 *
	 * @param int $t    timestamp
	 * @param bool $adv    "", "", ""
	 */
	public static function DateText($t,$adv)
	{
		$day=explode(',',date('Y,n,j,t',$t));
		$tod=explode(',',date('Y,n,j,t'));
		if($adv)
		{
			if($day[2]==$tod[2] and $day[1]==$tod[1] and $day[0]==$tod[0])
				return'Today';
			if($day[2]+1==$tod[2] and $tod[0]==$day[0] and $tod[1]==$day[1] or $day[1]+1==$tod[1] and $tod[0]==$day[0] and $tod[2]==1 and $day[3]==$day[2] or $day[0]+1==$tod[0] and $tod[2]==1 and $tod[1]==1 and $day[3]==$day[2])
				return'Yesterday';
			if($day[2]-1==$tod[2] and $tod[0]==$day[0] and $tod[1]==$day[1] or $day[1]-1==$tod[1] and $tod[0]==$day[0] and $tod[2]==$tod[3] and $day[2]==1 or $day[0]-1==$tod[0] and $tod[2]==$tod[3] and $tod[1]==12 and $day[2]==1)
				return'Tomorrow';
		}
		return date('m F Y',$t);
	}
}