<?php
/*
	Copyright  Eleanor CMS
	http://eleanor-cms.ru
	info@eleanor-cms.ru
*/

class Files
{
	/**
	 *       
	 * @param int $b  
	 */
	public static function BytesToSize($b)
	{
		/*
		if($b>1152921504606846976)
			return round($b/1152921504606846976,2).' eb';
		elseif($b>1125899906842624)
			return round($b/1125899906842624,2).' pb';
		elseif($b>1099511627776)
			return round($b/1099511627776,2).' tb';
		else*/if($b>=1073741824)
			return round($b/1073741824,2).' gb';
		elseif($b>=1048576)
			return round($b/1048576,2).' mb';
		elseif($b>=1024)
			return round($b/1024,2).' kb';
		return $b.' b';
		#b bk mb gb tb pb eb
	}

	/**
	 *        
	 * @param string $b   
	 */
	public static function SizeToBytes($b)
	{
		$bytes=(int)$b;
		if(isset($b[1]))
			switch(preg_match('#([a-z]+)\s*$#i',$b,$m)>0 ? strtolower($m[1]) : '')
			{
				/*
				case 'eb':
				case 'e':
					return $bytes*1152921504606846976;
				case 'pb':
				case 'p':
					return $bytes*1125899906842624;
				case 'tb':
				case 't':
					return $bytes*1099511627776;
				*/
				case'gb':
				case'g':
					return $bytes*1073741824;
				case'mb':
				case'm':
					return $bytes*1048576;
				case'kb':
				case'k':
					return $bytes*1024;
			}
		return$bytes;
	}

	/**
	 *      
	 * @param array $a  .     
	 */
	public static function OutputStream(array$a)
	{
		$a+=array(
			'data'=>'',#,   
			'file'=>'',#,      .    data
			'filename'=>false,# ,    
			'last-modified'=>mktime(0,0,0),#    (   )
			'multithread'=>true,#   
			'mimetype'=>false,# mimetype   
			'type'=>'',# 
			'etag'=>false,#Etag 
			'save'=>true,#       ?      false
		);

		if(headers_sent())
			die;
		ignore_user_abort(false);

		if(!$a['filename'])
			$a['filename']=$a['file'] ? basename($a['file']) : 'file'.$a['type'];
		if(!$a['mimetype'])
			$a['mimetype']=Types::MimeTypeByExt($a['type'] ? $a['type'] : $a['filename'],'auto-detect');

		if(!$a['data'] and !is_file($a['file']))
			throw new EE('No file '.$a['filename'],EE::DEV);

		$size=$a['data'] ? strlen($a['data']) : filesize($a['file']);
		#,  0 
		$zsize=$size-1;
		$etag=$a['etag'] ? $a['etag'] : md5($a['filename'].$a['mimetype']);
		$lm=$a['file'] ? filemtime($a['file']) : $a['last-modified'];
		header('Accept-Ranges: '.($a['multithread'] ? 'bytes' : 'none'));
		header('Connection: '.($a['multithread'] ? 'keep-alive' : 'close'));
		header('Content-Type: '.$a['mimetype']);
		header('Content-encoding: none');
		header('Etag: '.$etag);
		header('Date: '.gmdate('D, d M Y H:i:s').' GMT');
		header('Last-Modified: '.gmdate('D, d M Y H:i:s',$lm).' GMT');
		$fn=preg_match('#^[a-z0-9\-_\.\(\)]+$#i',$a['filename'])>0 ? $a['filename'] : '=?'.DISPLAY_CHARSET.'?B?'.base64_encode($a['filename']).'?=';
		if($a['save'])
			header('Content-Disposition: attachment; filename="'.$fn.'"');
		else
			header('Content-Disposition: inline; filename="'.$fn.'"');

		$ifr=isset($_SERVER['HTTP_IF_RANGE']) ? trim($_SERVER['HTTP_IF_RANGE']) : false;
		if($ifr and $ifr==$etag || strtotime($ifr)==$lm)
			$ifr=false;

		if($a['multithread'] and isset($_SERVER['HTTP_RANGE']) and !$ifr)
		{
			#  
			$range=array();
			$m=preg_match('/^bytes=((?:\d*-\d*,?\s?)+)/',$_SERVER['HTTP_RANGE'],$m)>0 ? explode(',',$m[1]) : array();
			foreach($m as $v)
			{
				$v=explode('-',trim($v),2);
				if($v[0])
				{
					#      
					if($v[0]>$zsize or ($v[1] and $v[0]>$v[1]))
						continue;
					if(!$v[1] or $v[1]>$zsize)
						$v[1]=$zsize;
				}
				elseif($v[1])
				{
					if(0>$v[0]=$zsize-$v[1])
						continue;
					$v[1]=$zsize;
				}
				else
					continue;
				$range[]=$v;
			}

			#   .. 500-799,600-1023,800-849 => 500-1023
			foreach($range as $k1=>&$v1)
				foreach($range as $k2=>&$v2)
					if($k1!==$k2 and $v2[0]>=$v1[0] and $v2[0]<=$v1[1])
					{
						if($v1[1]<$v2[1])
							$v1[1]=$v2[1];
						unset($range[$k2]);
					}
			# ?    .
			if(!$range)
			{
				header('HTTP/1.1 416 Requested range not satisfiable');
				die;
			}

			$s='';
			$total=0;
			foreach($range as &$v)
			{
				$s.=$v[0].'-'.$v[1].',';
				$total+=$v[1]-$v[0]+1;

				#  offset  length
				$v[1]-=$v[0]-1;
			}
			header('Content-Length: '.$total,true,206);
			header('Content-Range: bytes '.rtrim($s,',').'/'.$size);
		}
		else
		{
			header('Content-Length: '.$size,true,200);
			$range=array(array(0,$size));
		}

		if($a['data'])
			foreach($range as &$r)
			{
				echo substr($a['data'],$r[0],$r[1]);
				flush();
			}
		else
		{
			$f=fopen($a['file'],'rb');
			foreach($range as &$r)
			{
				fseek($f,$r[0],SEEK_SET);
				$d=0;
				while(!feof($f) and connection_status()==0 and $d<$r[1])
				{
					$b=min(1024*16,$r[1]-$d);
					$d+=$b;
					echo fread($f,$b);
					flush();
				}
			}
			fclose($f);
		}
		die;
	}

	/**
	 *    
	 * @param string $source :     
	 * @param string $dest : ,    
	 */
	public static function Copy($source,$dest)
	{
		$args=func_num_args();
		$origdest=$args==3 ? func_get_arg(2) : $dest;

		#    
		if($source=='' or !file_exists($source) or strpos($source,$origdest)===0)
			return false;

		#   
		$source=realpath($source);

		$destdir=dirname($dest);
		static::MkDir($destdir);
		$dest=realpath($destdir).DIRECTORY_SEPARATOR.basename($dest);

		if($args==2)
			$origdest=$dest;

		if(is_link($source) or Eleanor::$os=='w' and readlink($source)!=$source)#  
			return symlink(readlink($source),$dest);

		if(is_file($source))
			return copy($source,$dest);

		$f=__FUNCTION__;
		$files=array_diff(scandir($source),array('.','..'));

		foreach($files as $entry)
			static::$f($source.DIRECTORY_SEPARATOR.$entry,$dest.DIRECTORY_SEPARATOR.$entry,$origdest);

		return true;	
	}

	/**
	 *   .     ,   
	 * @param string $source :     
	 * @param string $dest : ,    
	 * @param bool $deldest    -
	 */
	public static function SymLink($source,$dest,$deldest=true)
	{
		# 
		$source=realpath($source);#   
		$dest=rtrim($dest,'/\\');

		/*
			        ,   *nix  - .
			http://lists.unixcenter.ru/archives/mlug/2004-April/025317.html
		*/
		$nix=Eleanor::$os!='w';

		if(!file_exists($source))
			return false;

		if(is_link($source))
		{
			$source=readlink($source);
			if($nix)
			{
				$source=realpath($source);
				$source=static::ShortPath($dest,$source);
			}
			return symlink($source,$dest);
		}

		if($deldest ? file_exists($dest) : is_file($dest))
			static::Delete($dest);

		if(is_file($source))
		{
			static::MkDir(dirname($dest));
			return symlink($nix ? static::ShortPath($dest,$source) : $source,$dest);
		}

		$f=__function__;
		$files=array_diff(scandir($source),array('.','..'));

		foreach($files as $entry)
			static::$f($source.DIRECTORY_SEPARATOR.$entry,$dest.DIRECTORY_SEPARATOR.$entry);

		return true;
	}

	/**
	 *    ,       
	 * @param string $temp ,    
	 * @param string $dest ""   ,   
	 */
	public static function UpdateDir($temp,$dest)
	{
		# 
		$temp=realpath($temp);#   
		$dest=rtrim($dest,'/\\');

		/*
			!  is_link     !
			   :  readlink($path)!=$path,    ,
			  ,          ,    .
		*/
		$windows=Eleanor::$os=='w';

		if($windows)
		{#readlink       \
			$temp=str_replace('/',DIRECTORY_SEPARATOR,$temp);
			$dest=str_replace('/',DIRECTORY_SEPARATOR,$dest);
		}

		if(!is_dir($temp))
			return false;

		$links=array_diff(scandir($temp),array('.','..'));

		# $dest       -     
		if(!is_dir($dest))
		{
			if(count($links)==0)
				return static::Delete($temp);

			if(file_exists($dest))
				static::Delete($dest);

			return rename($temp,$dest);
		}

		foreach($links as $k=>$file)
		{
			$fulltemp=$temp.DIRECTORY_SEPARATOR.$file;

			$fulltemp=realpath($fulltemp);#   
			if($windows ? is_file($fulltemp) && readlink($fulltemp)!=$fulltemp : is_link($fulltemp))
			{
				# : ,        
				$orig=readlink($fulltemp);

				if(!is_file($orig) || dirname($orig)!=$dest)
					throw new EE('DISPARATE_DIRS',EE::ENV);
				# ?
				elseif(basename($orig)!=$file)
					rename($orig,dirname($orig).DIRECTORY_SEPARATOR.$file);
			}
			# ?
			elseif(is_dir($fulltemp) and !is_dir($dest.DIRECTORY_SEPARATOR.$file))
				if(static::FixRanamedDir($fulltemp,$dest)==='d')
				{
					die(__line__.' Delete: '.$links[$k]);
					unset($links[$k]);
				}
		}

		$files=array_diff(scandir($dest),array('.','..'));

		# 
		foreach(array_diff($files,$links) as $file)
		{
			$fulldest=$dest.DIRECTORY_SEPARATOR.$file;
			$fulltemp=$temp.DIRECTORY_SEPARATOR.$file;

			#    ()
			if(is_dir($fulldest) or $windows ? !is_file($fulltemp) || readlink($fulltemp)==$fulltemp : !is_link($fulltemp))
				static::Delete($fulldest);
		}

		#  
		$f=__function__;
		foreach($links as $file)
		{
			$full=$temp.'/'.$file;
			$fulldest=$dest.'/'.$file;

			if(!in_array($file,$files))
				rename($full,$fulldest);
			elseif(is_dir($full))
				static::$f($full,$fulldest);
		}

		static::Delete($temp);
		return true;
	}

	/**
	 *  ,   .   UpdateDir
	 * @param string $path   ,  
	 * @param string $parent   -,     
	 * @return string d -  
	 */
	protected static function FixRanamedDir($path,$parent)
	{
		$links=array_diff(scandir($path),array('.','..'));
		$windows=Eleanor::$os=='w';#  

		if(!$links)
		{
			ReturnD:
			static::Delete($path);
			return'd';
		}

		$recrsym=false;# ,    
		$dirs=array();

		foreach($links as $k=>$file)
		{
			$full=$path.DIRECTORY_SEPARATOR.$file;
			if(is_dir($full))
				$dirs[$k]=$full;
			elseif($windows ? $rl=readlink($full) and $rl!=$full : is_link($full))
			{
				$orig=readlink($full);

				if(strpos($orig,$parent)===0)
				{
					#  
					$torename=substr(dirname($orig),strlen($parent)+1);
					$torename=explode(DIRECTORY_SEPARATOR,$torename);

					#   
					$names=explode(DIRECTORY_SEPARATOR,$path);
					$names=array_slice($names,-count($torename));

					#      ,   
					$recrsym=static::GetDelSym($path,$links);
					break;
				}
			}
		}

		if($recrsym===false)
		{
			$f=__function__;
			foreach($dirs as $k=>$dir)
				if(static::$f($dir,$parent)==='d')
					unset($links[$k]);

			if(!$links)
				goto ReturnD;
		}
		else
		{
			$from=$to=$parent;
			foreach($names as $k=>$name)
			{
				$from.=DIRECTORY_SEPARATOR.$torename[$k];
				$to.=DIRECTORY_SEPARATOR.$name;

				if(rename($parent.DIRECTORY_SEPARATOR.$torename[$k],$parent.DIRECTORY_SEPARATOR.$name))
					$parent.=DIRECTORY_SEPARATOR.$name;
				else
					return false;
			}

			foreach($recrsym as $k=>$v)
				symlink(str_replace($from,$to,$v),$k);
		}
	}

	public static function GetDelSym($path,array$links=array())
	{
		if(!$links)
		{
			$links=array_diff(scandir($path),array('.','..'));
			if(!$links)
			{
				static::Delete($path);
				return array();
			}
		}

		$windows=Eleanor::$os=='w';#  
		$recrsym=array();
		$f=__function__;

		foreach($links as $k=>$file)
		{
			$full=$path.DIRECTORY_SEPARATOR.$file;

			if(is_dir($full))
				$recrsym+=static::$f($full);
			elseif($windows ? $rl=readlink($full) and $rl!=$full : is_link($full))
			{
				$recrsym[ $full ]=readlink($full);
				unlink($full);
			}
		}

		return$recrsym;
	}

	/**
	 *  .      mkdir,      
	 * @param string $path   ,   
	 */
	public static function MkDir($path)
	{
		$f=__function__;

		if($path!='' and !is_dir($path))
		{
			static::$f(dirname($path));
			return mkdir($path);
		}

		return true;
	}

	/**
	 *  ,     
	 * @param string $path   ,      
	 */
	public static function Delete($path,$nocheck=false)
	{
		if(is_dir($path))
		{
			$f=__function__;
			$entries=array_diff(scandir($path),array('.','..'));

			foreach($entries as $entry)
				if(!static::$f($path.DIRECTORY_SEPARATOR.$entry,true))
					return true;

			return rmdir($path);
		}
		#  , file_exists   ,  $check
		return $nocheck||file_exists($path) ? unlink($path) : true;
	}

	/**
	 *   
	 * @param sting $path   ,    
	 * @param callback|FALSE   ,       -  .       ,   bool
	 * @return int      ,       
	 */
	public static function GetSize($path,$filter=false)
	{
		if(is_link($path))
			return 0;

		if(is_dir($path))
		{
			$size=0;
			$f=__function__;
			$entries=array_diff(scandir($path),array('.','..'));

			foreach($entries as $entry)
				$size+=static::$f($path.DIRECTORY_SEPARATOR.$entry,$filter);

			return$size;
		}

		return is_file($path) && (!is_callable($filter) or call_user_func($filter,$path)) ? filesize($path) : 0;
	}

	/**
	 *          Windows,       .
	 * @param string $f  
	 * @param bool $dec   (  )
	 */
	public static function Windows($f,$dec=false)
	{
		if(Eleanor::$os=='w' and CHARSET=='utf-8')
			$f=$dec ? mb_convert_encoding($f,CHARSET,'cp1251') : mb_convert_encoding($f,'cp1251');
		return$f;
	}

	/**
	 *    .    substr_replace,     .
	 *    ,      rb+.  a (   )   ( PHP)!
	 * @param resource $fh  ,   fopen
	 * @param string $s    ( 2   substr_replace)
	 * @param int $o    ( 3   substr_replace)
	 * @param int $l    ( 4   substr_replace)
	 * @param int $buf  ,   
	 */
	public static function FReplace($fh,$s,$o,$l=0,$buf=4096)
	{
		$len=strlen($s);
		if(!is_resource($fh) or $len==0 and $l==0)
			return false;

		#PHP 5.4 fstat($fh)['size'];
		$size=fstat($fh);
		$size=$size['size'];

		$diff=$len-$l;
		if($diff==0 and $o<$size)
		{
			fseek($fh,$o,SEEK_SET);
			fwrite($fh,$s);
		}
		elseif($o>=$size)
		{
			fseek($fh,0,SEEK_END);
			fwrite($fh,$s);
		}
		else
		{
			$diff=strlen($s)-$l;

			if($diff>0)
			{
				$step=1;
				$limiter=$o+$l;
				do
				{
					$i=$size-$buf*$step++;
					if($i>$limiter)
					{
						$seek=$i;
						fseek($fh,$seek,SEEK_SET);
						$data=fread($fh,$buf);
					}
					else
					{
						$seek=$limiter;
						fseek($fh,$seek,SEEK_SET);
						$data=fread($fh,$buf+$limiter-$i);
					}
					fseek($fh,$seek+$diff,SEEK_SET);
					fwrite($fh,$data);
				}while($i>$limiter);
			}
			else
			{
				for($i=$o+$l;$i<$size;$i+=$buf)
				{
					fseek($fh,$i,SEEK_SET);
					$data=fread($fh,min($buf,$size-$i));
					fseek($fh,$i+$diff,SEEK_SET);
					fwrite($fh,$data);
				}
				ftruncate($fh,$size+$diff);
			}
			if($len>0)
			{
				fseek($fh,$o,SEEK_SET);
				fwrite($fh,$s);
			}
		}
		return$diff;
	}

	/**
	 *          
	 * @param string $a    
	 * @param string $b    
	 * @return string : ../../aa/bb/cc
	 */
	public static function ShortPath($a,$b)
	{
		$a=preg_split('#[/\\\\]+#',$a);
		$b=preg_split('#[/\\\\]+#',$b);
		$m=min($acnt=count($a),count($b));
		for($i=0;$i<$m;++$i)
		{
			if($i==0 and $a[0]!=$b[0])
				return false;
			if($a[$i]!=$b[$i])
				break;
		}
		$acnt-=$i+1;
		$ret=$acnt>0 ? array_merge(array_fill(0,$acnt,'..'),array_slice($b,$i)) : array_slice($b,$i);
		return join('/',$ret);
	}
}